indexing
	description: "Objects that provide string codes for program point kinds in the format required for program point names suffixes by the old declarations format (with slight modification)"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_OLD_SUFFIX_FORMAT

inherit
	CI_PROGRAM_POINT_KIND_FORMAT

feature -- Program point kinds
	entry_kind: STRING is "ENTER"
			-- Name of routine entry program points in old Daikon program point name suffix format

	exit_kind: STRING is
			-- Name of routine exit program points in old Daikon program point name suffix format
		once
			Result := aggregative_exit_kind.string
			Result.append (default_exit_id)
		end

	stable_kind: STRING is "OBJECT"
			-- Name of stable program points in old Daikon program point name suffix format

	body_kind: STRING is "BODY"
			-- Name of routine body program points in old Daikon program point name suffix format

	loop_kind: STRING is "LOOP"
			-- Name of loop program points in old Daikon program point name suffix format

	surrogate_loop_kind: STRING is "OBJECT"
			-- Name of surrogate loop program points in old Daikon program point name suffix format
			-- OBJECT because Daikon trhows exception otherwise

	surrogate_function_exit_kind: STRING is "OBJECT"
			-- Name of surrogate function program points in old Daikon program point name suffix format
			-- OBJECT because Daikon trhows exception otherwise

feature -- Constants
	aggregative_exit_kind: STRING is "EXIT"
			-- Name of aggregative routine exit (in Daikon output, but not in input)

	default_exit_id: STRING is "1"
			-- Identifier of routine exit program point
			-- Since there is only one exit from each routine in Eiffel, exact id is replaces with this default value							
end
