indexing
	description: "Objects that provide string codes for program point kinds in the format required for ppt-type tags in the new declarations format"
	author: "Nadia Polikarpova"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_PPT_TYPE_FORMAT

inherit
	CI_PROGRAM_POINT_KIND_FORMAT

feature -- Program point kinds
	entry_kind: STRING is "enter"
			-- Name of routine entry program points in ppt-type tag format

	exit_kind: STRING is "subexit"
			-- Name of routine exit program points in ppt-type tag format

	stable_kind: STRING is "object"
			-- Name of stable program points in ppt-type tag format

	body_kind: STRING is
			-- Name of routine body program points in ppt-type tag format
		once
			Result := default_kind
		end

	loop_kind: STRING is
			-- Name of loop program points in ppt-type tag format
		once
			Result := default_kind
		end

	surrogate_loop_kind: STRING is
			-- Name of surogate loop program points in ppt-type tag format
		once
			Result := "object"--default_kind
		end

	surrogate_function_exit_kind: STRING is
			-- Name of surrogate function program points in ppt-type tag format
		once
			Result := "object"--default_kind
		end

feature {NONE} -- Implementation
	default_kind: STRING is "point"
			-- "Safe" default
end
