indexing
	description: "Objects that provide string codes for program point kinds in specific formats (visitor pattern)"
	author: "Nadia Polikarpova"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	CI_PROGRAM_POINT_KIND_FORMAT

feature -- Access
	entry_kind: STRING is
			-- Name of routine entry program points
		deferred
		end

	exit_kind: STRING is
			-- Name of routine exit program points
		deferred
		end

	function_entry_kind: STRING is
			-- Name of function entry program points: by default the same as procedure entry
		do
			Result := entry_kind
		end

	function_exit_kind: STRING is
			-- Name of function exit program points: by default the same as procedure exit
		do
			Result := exit_kind
		end

	stable_kind: STRING is
			-- Name of stable-time program points
		deferred
		end

	body_kind: STRING is
			-- Name of routine body program points with position `position'
		deferred
		end

	loop_kind: STRING is
			-- Name of loop program points with position `position'
		deferred
		end

	surrogate_loop_kind: STRING is
			-- Name of surrogate_loop program points with position `position'
		deferred
		end

	surrogate_function_exit_kind: STRING is
			-- Name of surrogate_function program points with position `position'
		deferred
		end

invariant
	entry_kind_exists: entry_kind /= Void
	exit_kind_exists: exit_kind /= Void
	stable_kind_exists: stable_kind /= Void
	body_kind_exists: body_kind /= Void
	loop_kind_exists: loop_kind /= Void
	surrogate_loop_kind_exists: surrogate_loop_kind /= Void
	surrogate_function_exit_kind_exists: surrogate_function_exit_kind /= Void
end
