indexing
	description: "Helpers for supplier invariant suppressions: renames everything into Current (for quesries tries on multiple level starting from the shallow and going deeper)"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_SUPPLIER_INVARIANT_HELPER

inherit
	CI_SUPPRESSION
		redefine
			suppressor,
			renamed_query
		end

create {CI_SUPPLIER_INVARIANT_SUPPRESSION}
	make

feature -- Access
	suppressor: CI_STABLE_TIME
			-- Suppressor program point	

feature -- Variable renaming
	renamed_current (a_variable: CI_CURRENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_argument (a_variable: CI_FORMAL_ARGUMENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
			if a_variable.type.base_class.is_equal (suppressor.surrounding_class) then
				create {CI_CURRENT} Result.make (Void, a_variable.type.base_class, a_variable.type.universe)
			end
		end

	renamed_local (a_variable: CI_LOCAL_ENTITY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
			if a_variable.type.base_class.is_equal (suppressor.surrounding_class) then
				create {CI_CURRENT} Result.make (Void, a_variable.type.base_class, a_variable.type.universe)
			end
		end

	renamed_result (a_variable: CI_RESULT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
			if a_variable.type.base_class.is_equal (suppressor.surrounding_class) then
				create {CI_CURRENT} Result.make (Void, a_variable.type.base_class, a_variable.type.universe)
			end
		end

	renamed_query (a_variable: CI_QUERY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		local
			target: CI_VARIABLE
		do
			if a_variable.type.base_class.is_equal (suppressor.surrounding_class) then
				create {CI_CURRENT} Result.make (Void, a_variable.type.base_class, a_variable.type.universe)
			else
				target := a_variable.target.renamed (Current)
				if target /= Void then
					create {CI_QUERY} Result.make (a_variable.ast_node, target)
				end
			end
		end
end
