indexing
	description: "Suppression between program points"
	author: "Markus Pilman"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	CI_SUPPRESSION

feature {NONE} -- Initialization
	make (a_suppressor: CI_PROGRAM_POINT) is
			-- Create a suppression by `a_suppressor'
		require
			a_suppressor_exists: a_suppressor /= Void
		do
			suppressor := a_suppressor
		ensure
			suppressor_set: suppressor = a_suppressor
		end

feature -- Access
	suppressor: CI_PROGRAM_POINT
			-- Suppressor program point

feature -- Variable renaming
	renamed_current (a_variable: CI_CURRENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		deferred
		end

	renamed_argument (a_variable: CI_FORMAL_ARGUMENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		deferred
		end

	renamed_local (a_variable: CI_LOCAL_ENTITY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		deferred
		end

	renamed_result (a_variable: CI_RESULT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		deferred
		end

	renamed_query (a_variable: CI_QUERY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		local
			target: CI_VARIABLE
		do
			target := a_variable.target.renamed (Current)
			if target /= Void then
				create {CI_QUERY} Result.make (a_variable.ast_node, target)
			end
		end

invariant
	suppressor_exists: suppressor /= Void
end
