indexing
	description: "Variables that respesent compile-time constants"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_CONSTANT

inherit
	CI_VARIABLE
		redefine
			constant
		end

create
	make

feature {NONE} -- Initialization
	make (a_constant_attribute: like ast_node; a_surrounding_routine: like surrounding_routine; a_universe: ET_UNIVERSE) is
			-- Create variable that corresponds to `a_constant_attribute'
		do
			ast_node := a_constant_attribute
			surrounding_routine := a_surrounding_routine

			create type.make (ast_node.type, ast_node.implementation_class, a_universe)
			create clients.make
			create evaluation_preconditions.make
		end

feature -- Access
	ast_node: ET_CONSTANT_ATTRIBUTE
			-- An AST node that corresponds to variable	

	name: STRING is
			-- String representation of query name in Daikon format
		do
			Result := "{"
			Result.append (ast_node.implementation_class.upper_name)
			Result.append ("}.")
			Result.append (ast_node.lower_name)
		end

	constant: ET_CONSTANT is
			-- Compile-time constant value of variable (void if not a constant)
		do
			Result := ast_node.constant
		end

feature -- Evaluation
	as_expression: ET_EXPRESSION is
			-- Variable viewed as Eiffel expression; to be used as target for queries
		do
			Result := ast_node.constant
		end

feature {CI_VARIABLE_TYPE_KIND} -- Evaluation
	address_expression: ET_ADDRESS_EXPRESSION is
			-- Is never used
		do
		end

feature -- Suppression
	renamed (a_suppresion: CI_SUPPRESSION): CI_VARIABLE is
			-- Name of this variable in the suppressor program point from `a_suppression'
			-- The same for all suppressions
		do
			Result := Current
		end
end
